package org.relaxng.xpathlib;

import org.relaxng.datatype.*;
import org.relaxng.datatype.helpers.ParameterlessDatatypeBuilder;
import java.util.Map;

public class DataTypeLibraryImpl implements DatatypeLibrary {
	
	public DatatypeBuilder createDatatypeBuilder( String baseTypeLocalName ) {
		Datatype type = createDatatype(baseTypeLocalName);
		if(type==null)	return null;
		return new ParameterlessDatatypeBuilder(type);
	}
	
	/** the map from type name to DataType object. */
	static protected Map types = createTypes();
	static Map createTypes() {
		Map m = new java.util.HashMap();
		
		m.put( "XPath",			new DatatypeImpl(){
			protected void run( XPathParser p ) throws Exception { p.XPath(); }
		});
		m.put( "XSLTPattern",	new DatatypeImpl(){
			protected void run( XPathParser p ) throws Exception { p.Pattern(); }
		});
		m.put( "AbsoluteLocationPath",	new DatatypeImpl(){
			protected void run( XPathParser p ) throws Exception { p.AbsoluteLocationPath(); }
		});
		m.put( "RelativeLocationPath",	new DatatypeImpl(){
			protected void run( XPathParser p ) throws Exception { p.RelativeLocationPath(); }
		});
		
		return m;
	}
	
	public Datatype createDatatype( String localTypeName ) {
		return (Datatype)types.get(localTypeName);
	}
}
